diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.c b/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.c
new file mode 100644
index 0000000..7036d23
--- /dev/null
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.c
@@ -0,0 +1,362 @@
+/*********************************************************
+ * Copyright (C) 2012 VMware, Inc. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation version 2 and no later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ *
+ *********************************************************/
+#include "backdoor_balloon.h"
+#include "backdoor.h"
+#include "balloon_def.h"
+#include "os.h"
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * BackdoorCmd --
+ *
+ *      Do the balloon hypercall to the vmkernel.
+ *
+ * Results:
+ *      Hypercall status will be returned and out will be filled
+ *      if it's not NULL, either by bx or cx depending on the command.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+static int
+BackdoorCmd(uint16 cmd,     // IN
+            size_t arg1,    // IN
+            uint32 arg2,    // IN
+            uint32 *out,    // OUT
+            int *resetFlag) // OUT
+{
+   Backdoor_proto bp;
+   int status;
+
+   /* prepare backdoor args */
+   bp.in.cx.halfs.low = cmd;
+   bp.in.size = arg1;
+   bp.in.si.word = arg2;
+
+   /* invoke backdoor */
+   bp.in.ax.word = BALLOON_BDOOR_MAGIC;
+   bp.in.dx.halfs.low = BALLOON_BDOOR_PORT;
+   Backdoor_InOut(&bp);
+
+   status = bp.out.ax.word;
+   /* set flag if reset requested */
+   if (status == BALLOON_ERROR_RESET) {
+      *resetFlag = 1;
+   }
+
+   if (out) {
+      if (cmd == BALLOON_BDOOR_CMD_START) {
+         *out = bp.out.cx.word;
+      } else {
+         *out = bp.out.bx.word;
+      }
+   }
+
+   return status;
+}
+
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorStart --
+ *
+ *      Attempts to contact monitor via backdoor to begin operation.
+ *
+ * Results:
+ *      Returns BALLOON_SUCCESS if successful, otherwise error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorStart(Balloon *b,               // IN
+                      uint32 protoVersion)      // IN
+{
+   uint32 capabilities;
+   int status = BackdoorCmd(BALLOON_BDOOR_CMD_START, protoVersion, 0,
+                            &capabilities, &b->resetFlag);
+   /*
+    * If return code is BALLOON_SUCCESS_WITH_CAPABILITY, then ESX is
+    * sending the common capabilities supported by the monitor and the
+    * guest in cx.
+    */
+   if (status == BALLOON_SUCCESS_WITH_CAPABILITIES) {
+      b->hypervisorCapabilities = capabilities;
+      status = BALLOON_SUCCESS;
+   } else if (status == BALLOON_SUCCESS) {
+      b->hypervisorCapabilities = BALLOON_BASIC_CMDS;
+   }
+
+   /* update stats */
+   STATS_INC(b->stats.start);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.startFail);
+   }
+
+   return status;
+}
+
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorGuestType --
+ *
+ *      Attempts to contact monitor and report guest OS identity.
+ *
+ * Results:
+ *      Returns BALLOON_SUCCESS if successful, otherwise error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorGuestType(Balloon *b) // IN
+{
+   int status = BackdoorCmd(BALLOON_BDOOR_CMD_GUEST_ID, b->guestType, 0,
+                            NULL, &b->resetFlag);
+
+   /* update stats */
+   STATS_INC(b->stats.guestType);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.guestTypeFail);
+   }
+
+   return status;
+}
+
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorGetTarget --
+ *
+ *      Attempts to contact monitor via backdoor to obtain desired
+ *      balloon size.
+ *
+ *      Predicts the maximum achievable balloon size and sends it
+ *      to vmm => vmkernel via vEbx register.
+ *
+ *      OS_ReservedPageGetLimit() returns either predicted max balloon
+ *      pages or BALLOON_MAX_SIZE_USE_CONFIG. In the later scenario,
+ *      vmkernel uses global config options for determining a guest's max
+ *      balloon size. Note that older vmballoon drivers set vEbx to
+ *      BALLOON_MAX_SIZE_USE_CONFIG, i.e., value 0 (zero). So vmkernel
+ *      will fallback to config-based max balloon size estimation.
+ *
+ * Results:
+ *      If successful, sets "target" to value obtained from monitor,
+ *      and returns BALLOON_SUCCESS. Otherwise returns error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorGetTarget(Balloon *b,     // IN
+                          uint32 *target) // OUT
+{
+   unsigned long limit;
+   uint32 limit32;
+   int status;
+
+   limit = OS_ReservedPageGetLimit();
+
+   /* Ensure limit fits in 32-bits */
+   limit32 = (uint32)limit;
+   if (limit32 != limit) {
+      return BALLOON_FAILURE;
+   }
+
+   status = BackdoorCmd(BALLOON_BDOOR_CMD_TARGET, limit, 0, target,
+                        &b->resetFlag);
+
+   /* update stats */
+   STATS_INC(b->stats.target);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.targetFail);
+   }
+
+   return status;
+}
+
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorLockPage --
+ *
+ *      Attempts to contact monitor and add PPN corresponding to
+ *      the page handle to set of "balloon locked" pages.
+ *      If the current protocol support batching, it will balloon all
+ *      PPNs listed in the batch page.
+ *
+ * Results:
+ *      Returns BALLOON_SUCCESS if successful, otherwise error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorLockPage(Balloon *b,    // IN
+                         PPN64 ppn)     // IN
+{
+   int status;
+   uint32 ppn32 = (uint32)ppn;
+
+   /* Ensure PPN fits in 32-bits, i.e. guest memory is limited to 16TB. */
+   if (ppn32 != ppn) {
+      return BALLOON_ERROR_PPN_INVALID;
+   }
+
+   status = BackdoorCmd(BALLOON_BDOOR_CMD_LOCK, ppn32, 0, NULL,
+                        &b->resetFlag);
+
+   /* update stats */
+   STATS_INC(b->stats.lock);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.lockFail);
+   }
+
+   return status;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorUnlockPage --
+ *
+ *      Attempts to contact monitor and remove PPN corresponding to
+ *      the page handle from set of "balloon locked" pages.
+ *      If the current protocol support batching, it will remove all
+ *      the PPNs listed in the batch page.
+ *
+ * Results:
+ *      Returns BALLOON_SUCCESS if successful, otherwise error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorUnlockPage(Balloon *b,  // IN
+                           PPN64 ppn)   // IN
+{
+   int status;
+   uint32 ppn32 = (uint32)ppn;
+
+   /* Ensure PPN fits in 32-bits, i.e. guest memory is limited to 16TB. */
+   if (ppn32 != ppn) {
+      return BALLOON_ERROR_PPN_INVALID;
+   }
+
+   status = BackdoorCmd(BALLOON_BDOOR_CMD_UNLOCK, ppn32, 0, NULL,
+                        &b->resetFlag);
+
+   /* update stats */
+   STATS_INC(b->stats.unlock);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.unlockFail);
+   }
+
+   return status;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorLockPagesBatched --
+ *
+ *      Balloon all PPNs listed in the batch page.
+ *
+ * Results:
+ *      Returns BALLOON_SUCCESS if successful, otherwise error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorLockPagesBatched(Balloon *b,    // IN
+                                 PPN64 ppn,     // IN
+                                 uint32 nPages) // IN
+{
+   int status = BackdoorCmd(BALLOON_BDOOR_CMD_BATCHED_LOCK,
+                            (size_t)ppn, nPages, NULL, &b->resetFlag);
+
+   /* update stats */
+   STATS_INC(b->stats.lock);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.lockFail);
+   }
+
+   return status;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Backdoor_MonitorUnlockPagesBatched --
+ *
+ *      Unballoon all PPNs listed in the batch page.
+ *
+ * Results:
+ *      Returns BALLOON_SUCCESS if successful, otherwise error code.
+ *
+ * Side effects:
+ *      None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Backdoor_MonitorUnlockPagesBatched(Balloon *b,          // IN
+                                   PPN64 ppn,           // IN
+                                   uint32 nPages)       // IN
+{
+   int status = BackdoorCmd(BALLOON_BDOOR_CMD_BATCHED_UNLOCK,
+                            (size_t)ppn, nPages, NULL, &b->resetFlag);
+
+   /* update stats */
+   STATS_INC(b->stats.unlock);
+   if (status != BALLOON_SUCCESS) {
+      STATS_INC(b->stats.unlockFail);
+   }
+
+   return status;
+}
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.h b/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.h
index 7d06d08..9036f95 100644
--- a/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.h
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/backdoor_balloon.h
@@ -26,14 +26,16 @@
 #ifndef _BACKDOOR_BALLOON_H_
 #define _BACKDOOR_BALLOON_H_
 
+#include "vmballoon.h"
 #include "backdoor.h"
 #include "balloon_def.h"
 
-static INLINE
-void Backdoor_Balloon(Backdoor_proto *myBp) {
-   myBp->in.ax.word = BALLOON_BDOOR_MAGIC;
-   myBp->in.dx.halfs.low = BALLOON_BDOOR_PORT;
-   Backdoor_InOut(myBp);
-}
+int Backdoor_MonitorStart(Balloon *b, uint32 protoVersion);
+int Backdoor_MonitorGuestType(Balloon *b);
+int Backdoor_MonitorGetTarget(Balloon *b, uint32 *target);
+int Backdoor_MonitorLockPage(Balloon *b, PPN64 ppn);
+int Backdoor_MonitorUnlockPage(Balloon *b, PPN64 ppn);
+int Backdoor_MonitorLockPagesBatched(Balloon *b, PPN64 ppn, uint32 nPages);
+int Backdoor_MonitorUnlockPagesBatched(Balloon *b, PPN64 ppn, uint32 nPages);
 
 #endif /* _BACKDOOR_BALLOON_H_ */
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/balloonInt.h b/sys/gnu/dev/virtual/vmware/vmmemctl/balloonInt.h
new file mode 100644
index 0000000..3a4225f
--- /dev/null
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/balloonInt.h
@@ -0,0 +1,75 @@
+/*********************************************************
+ * Copyright (C) 2012 VMware, Inc. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation version 2 and no later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ *
+ *********************************************************/
+#ifndef BALLOONINT_H_
+# define BALLOONINT_H_
+
+/*
+ * Compile-Time Options
+ */
+
+#define BALLOON_NAME                    "vmmemctl"
+#define BALLOON_NAME_VERBOSE            "VMware memory control driver"
+
+#if defined __linux__ || defined __FreeBSD__ || defined _WIN32
+/*
+ * FIXME: Even if the driver support batched commands keep using the
+ * non-batched one until more testing has been done.
+ */
+#define BALLOON_CAPABILITIES    BALLOON_BASIC_CMDS
+#else
+#define BALLOON_CAPABILITIES    BALLOON_BASIC_CMDS
+#endif
+
+#define BALLOON_RATE_ADAPT      1
+
+#define BALLOON_DEBUG           1
+#define BALLOON_DEBUG_VERBOSE   0
+
+#define BALLOON_POLL_PERIOD             1 /* sec */
+#define BALLOON_NOSLEEP_ALLOC_MAX       16384
+
+#define BALLOON_RATE_ALLOC_MIN          512
+#define BALLOON_RATE_ALLOC_MAX          2048
+#define BALLOON_RATE_ALLOC_INC          16
+
+#define BALLOON_RATE_FREE_MIN           512
+#define BALLOON_RATE_FREE_MAX           16384
+#define BALLOON_RATE_FREE_INC           16
+
+/*
+ * Move it to bora/public/balloon_def.h later, if needed. Note that
+ * BALLOON_PAGE_ALLOC_FAILURE is an internal error code used for
+ * distinguishing page allocation failures from monitor-backdoor errors.
+ * We use value 1000 because all monitor-backdoor error codes are < 1000.
+ */
+#define BALLOON_PAGE_ALLOC_FAILURE      1000
+
+#define BALLOON_STATS
+
+#ifdef	BALLOON_STATS
+#define	STATS_INC(stat)	(stat)++
+#define	STATS_DEC(stat)	(stat)--
+#else
+#define	STATS_INC(stat)
+#define	STATS_DEC(stat)
+#endif
+
+#define PPN_2_PA(_ppn)  ((_ppn) << PAGE_SHIFT)
+#define PA_2_PPN(_pa)   ((_pa) >> PAGE_SHIFT)
+
+#endif /* !BALLOONINT_H_ */
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/balloon_def.h b/sys/gnu/dev/virtual/vmware/vmmemctl/balloon_def.h
index 20a4348..9e06c11 100644
--- a/sys/gnu/dev/virtual/vmware/vmmemctl/balloon_def.h
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/balloon_def.h
@@ -1,5 +1,5 @@
 /*********************************************************
- * Copyright (C) 2000 VMware, Inc. All rights reserved.
+ * Copyright (C) 2000-2012 VMware, Inc. All rights reserved.
  *
  * This program is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by the
@@ -33,6 +33,8 @@
 #include "includeCheck.h"
 
 #include "vm_basic_types.h"
+#include "vm_basic_defs.h"
+#include "vm_assert.h"
 
 /*
  * constants
@@ -42,12 +44,55 @@
 #define BALLOON_BDOOR_PORT              (0x5670)
 #define BALLOON_BDOOR_MAGIC             (0x456c6d6f)
 
+/*
+ * Backdoor commands availability:
+ *
+ * +====================+======================+
+ * |    CMD             | Capabilities         |
+ * +--------------------+----------------------+
+ * | START              | Always available (*) |
+ * | TARGET             | Always available     |
+ * | LOCK               | BASIC_CMDS           |
+ * | UNLOCK             | BASIC_CMDS           |
+ * | GUEST_ID           | Always available     |
+ * | BATCHED_LOCK       | BATCHED_CMDS         |
+ * | BATCHED_UNLOCK     | BATCHED_CMDS         |
+ * +====================+======================+
+ *
+ * (*) The START command has been slightly modified when more than the
+ * basic commands are available: It returns
+ * BALLOON_SUCCESS_WITH_CAPABILITIES with the available capabilities
+ * stored in %ecx. Previously, a versioned protocol was used, and the
+ * protocol that should be used was also returned in %ecx. Protocol
+ * version 2 was the initial version and the only one shipped. Version 3
+ * was temporary used internally but has caused several issue due to
+ * protocol mismatch between monitor and guest.
+ *
+ */
+
 /* backdoor command numbers */
 #define BALLOON_BDOOR_CMD_START         (0)
 #define BALLOON_BDOOR_CMD_TARGET        (1)
 #define BALLOON_BDOOR_CMD_LOCK          (2)
 #define BALLOON_BDOOR_CMD_UNLOCK        (3)
 #define BALLOON_BDOOR_CMD_GUEST_ID      (4)
+/* The command 5 was shortly used between 1881144 and 1901153. */
+#define BALLOON_BDOOR_CMD_BATCHED_LOCK   (6)
+#define BALLOON_BDOOR_CMD_BATCHED_UNLOCK (7)
+
+/* balloon capabilities */
+typedef enum {
+   /*
+    * Bit 0 is not used and shouldn't be used, due to issue with
+    * protocol v3, to avoid ambiguity between protocol v3 and
+    * capabilities, leave this bit as 0. That way, by masking guest
+    * capabilities with monitor capabilities, bit 0 will always be set
+    * to 0, and buggy v3 tool will automatically switch to unbatched
+    * LOCK and UNLOCK.
+    */
+   BALLOON_BASIC_CMDS           = (1 << 1),
+   BALLOON_BATCHED_CMDS         = (1 << 2)
+} BalloonCapabilities;
 
 /* use config value for max balloon size */
 #define BALLOON_MAX_SIZE_USE_CONFIG     (0)
@@ -80,4 +125,143 @@ typedef enum {
 #define BALLOON_ERROR_RESET             (7)
 #define BALLOON_ERROR_BUSY              (8)
 
+#define BALLOON_SUCCESS_WITH_CAPABILITIES       (0x03000000)
+
+/*
+ * BatchPage.
+ */
+#define BALLOON_BATCH_MAX_PAGES         (PAGE_SIZE / sizeof(PA64))
+
+/*
+ * We are using the fact that for 4k pages, the 12LSB are set to 0, so
+ * we can use them and mask those bit when we need the real PA.
+ *
+ * +=============+==========+========+
+ * |             |          |        |
+ * | Page number | Reserved | Status |
+ * |             |          |        |
+ * +=============+==========+========+
+ * 64  PAGE_SHIFT          6         0
+ *
+ * For now, only 4k pages are supported by the monitor, but by using
+ * reserved bit we can in the future add some flags that will indicate
+ * whether the page is a 2M page or a 1G page.
+ *
+ * The reserved field should be set to 0.
+ *
+ */
+
+
+#define BALLOON_BATCH_STATUS_MASK       MASK64(5)
+#define BALLOON_BATCH_PAGE_MASK         (~MASK64(PAGE_SHIFT))
+
+typedef struct BalloonBatchPage {
+   PA64 pages[BALLOON_BATCH_MAX_PAGES];
+} BalloonBatchPage;
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Balloon_BatchGetPA --
+ *
+ *      Get the page stored in the batch page at idx.
+ *
+ * Results:
+ *      See above.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE PA64
+Balloon_BatchGetPA(BalloonBatchPage *batchPage,         // IN
+                   uint16 idx)                          // IN
+{
+   ASSERT(idx < BALLOON_BATCH_MAX_PAGES);
+   return batchPage->pages[idx] & BALLOON_BATCH_PAGE_MASK;
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Balloon_BatchGetStatus --
+ *
+ *      Get the error code associated with a page.
+ *
+ * Results:
+ *      See above.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE uint8
+Balloon_BatchGetStatus(BalloonBatchPage *batchPage,     // IN
+                       uint16 idx)                      // IN
+{
+   ASSERT(idx < BALLOON_BATCH_MAX_PAGES);
+   return (uint8)(batchPage->pages[idx] & BALLOON_BATCH_STATUS_MASK);
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Balloon_BatchSetPA --
+ *
+ *      Store the page in the batch page at idx.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE void
+Balloon_BatchSetPA(BalloonBatchPage *batchPage,            // IN
+                   uint16 idx,                             // IN
+                   PA64 pa)                                // IN
+{
+   ASSERT(idx < BALLOON_BATCH_MAX_PAGES);
+   ASSERT((pa & ~BALLOON_BATCH_PAGE_MASK) == 0);
+   batchPage->pages[idx] = pa;
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Balloon_BatchSetStatus --
+ *
+ *      Set the error code associated with a page.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+static INLINE void
+Balloon_BatchSetStatus(BalloonBatchPage *batchPage,      // IN
+                       uint16 idx,                       // IN
+                       int error)                        // IN
+{
+   PA64 pa = Balloon_BatchGetPA(batchPage, idx);
+   ASSERT(idx < BALLOON_BATCH_MAX_PAGES);
+   ASSERT(error <= BALLOON_ERROR_BUSY && error >= BALLOON_FAILURE);
+   batchPage->pages[idx] = pa | (PPN64)error;
+}
+
+MY_ASSERTS(BALLOON_BATCH_SIZE,
+           ASSERT_ON_COMPILE(sizeof(BalloonBatchPage) == PAGE_SIZE);
+)
+
 #endif  /* _BALLOON_DEF_H */
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubs.h b/sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubs.h
new file mode 100644
index 0000000..8630c32
--- /dev/null
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubs.h
@@ -0,0 +1,89 @@
+/*********************************************************
+ * Copyright (C) 2006 VMware, Inc. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation version 2 and no later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ *
+ *********************************************************/
+
+/*
+ * kernelStubs.h
+ *
+ * KernelStubs implements some userspace library functions in terms
+ * of kernel functions to allow library userspace code to be used in a
+ * kernel.
+ */
+
+#ifndef __KERNELSTUBS_H__
+#define __KERNELSTUBS_H__
+
+#include "vm_basic_types.h"
+#ifndef _KERNEL
+#   error "_KERNEL is not defined"
+#endif
+#include <sys/types.h>
+#include <sys/malloc.h>
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <machine/stdarg.h>
+#include <sys/libkern.h>
+
+/*
+ * Function Prototypes
+ */
+
+/* Kernel memory on FreeBSD is tagged for statistics and sanity checking. */
+MALLOC_DECLARE(M_VMWARE_TEMP);
+
+/*
+ * On FreeBSD, the general memory allocator for both userland and the kernel is named
+ * malloc, but the kernel malloc() takes more arguments.  The following alias & macros
+ * work around this, to provide the standard malloc() API for userspace code that is
+ * being used in the kernel.
+ */
+
+#undef malloc
+
+static INLINE void *
+__compat_malloc(unsigned long size, struct malloc_type *type, int flags) {
+   return kmalloc(size, type, flags);
+}
+
+#define malloc(size)         __compat_malloc(size, M_VMWARE_TEMP, M_NOWAIT)
+#define calloc(count, size)  __compat_malloc((count) * (size),       \
+                                                M_VMWARE_TEMP, M_NOWAIT|M_ZERO)
+#define realloc(buf, size)   krealloc(buf, size, M_VMWARE_TEMP, M_NOWAIT)
+#define free(buf)            kfree(buf, M_VMWARE_TEMP)
+#define strchr(s,c)          index(s,c)
+#define strrchr(s,c)         rindex(s,c)
+
+/*
+ * Stub functions we provide.
+ */
+
+void Panic(const char *fmt, ...);
+
+char *Str_Strcpy(char *buf, const char *src, size_t maxSize);
+int Str_Vsnprintf(char *str, size_t size, const char *format,
+                  __va_list arguments);
+char *Str_Vasprintf(size_t *length, const char *format,
+                    __va_list arguments);
+char *Str_Asprintf(size_t *length, const char *Format, ...);
+
+/*
+ * Functions the driver must implement for the stubs.
+ */
+EXTERN void Debug(const char *fmt, ...);
+
+
+#endif /* __KERNELSTUBS_H__ */
diff --git a/sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubsBSD.c b/sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubsBSD.c
new file mode 100644
index 0000000..9d45331
--- /dev/null
+++ b/sys/gnu/dev/virtual/vmware/vmmemctl/kernelStubsBSD.c
@@ -0,0 +1,259 @@
+/*********************************************************
+ * Copyright (C) 2007 VMware, Inc. All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation version 2 and no later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ *
+ *********************************************************/
+
+/*
+ * kernelStubsBSD.c --
+ *
+ *      Stub functions for use by miscellaneous VMware code when brought into
+ *      the FreeBSD kernel.
+ */
+
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <machine/stdarg.h>
+#include <sys/systm.h>
+#include <sys/kernel.h>
+
+#include "kernelStubs.h"
+
+MALLOC_DEFINE(M_VMWARE_TEMP, "VMwareTemp", "VMware: Temporary Allocations");
+
+void Log (const char *fmt, ...) __attribute__ ((alias ("Debug")));
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Debug --
+ *
+ *      Send a debugging message to the system log and/or console.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+void
+Debug(const char *fmt, ...)
+{
+   __va_list ap;
+
+   __va_start(ap, fmt);
+   kvprintf(fmt, ap);
+   __va_end(ap);
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Panic --
+ *
+ *      Print a panic message & induce a kernel panic.
+ *
+ * Results:
+ *      Does not return.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+void
+Panic(const char *fmt, ...)
+{
+   __va_list ap;
+
+   __va_start(ap, fmt);
+   kvprintf(fmt, ap);
+   __va_end(ap);
+
+   panic(" ");
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Str_Strcpy --
+ *
+ *      Wrapper around strcpy that panics if the source is too long.
+ *
+ * Results:
+ *      Returns a pointer to buf.
+ *
+ * Side effects:
+ *      None.
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+char *
+Str_Strcpy(char *buf,           // OUT: destination buffer
+           const char *src,     // IN : source buffer
+           size_t maxSize)      // IN : size of buf
+{
+   size_t srcLen = strlen(src);
+   if (srcLen >= maxSize) {
+      panic("%s:%d Buffer too small %p\n", __FILE__, __LINE__, buf);
+   }
+   return memcpy(buf, src, srcLen + 1);    // Extra byte = terminator
+}
+
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Str_Vsnprintf --
+ *
+ *      Compatibility wrapper for kvsnprintf(1).
+ *
+ * Results:
+ *
+ *      int - number of bytes stored in 'str' (not including null
+ *      terminate character), -1 on overflow (insufficient space for
+ *      null terminate is considered overflow)
+ *
+ *      NB: on overflow the buffer WILL be null terminated
+ *
+ * Side effects:
+ *      None
+ *
+ *----------------------------------------------------------------------
+ */
+
+int
+Str_Vsnprintf(char *str,                // OUT: destination buffer
+              size_t size,              // IN : size of str
+              const char *format,       // IN : format for kvsnprintf
+              __va_list arguments)        // IN : variadic args for kvsnprintf
+{
+   int retval;
+
+   retval = kvsnprintf(str, size, format, arguments);
+   if (retval >= size) {
+      retval = -1;
+   }
+   return retval;
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Str_Vasprintf --
+ *
+ *    Allocate and format a string, using the GNU libc way to specify the
+ *    format (i.e. optionally allow the use of positional parameters)
+ *
+ * Results:
+ *    The allocated string on success (if 'length' is not NULL, *length
+ *       is set to the length of the allocated string)
+ *    NULL on failure
+ *
+ * Side effects:
+ *    None
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+char *
+Str_Vasprintf(size_t *length,       // OUT
+              const char *format,   // IN
+              __va_list arguments)    // IN
+{
+   /*
+    * Simple implementation of Str_Vasprintf when userlevel libraries are not
+    * available (e.g. for use in drivers). We just fallback to kvsnprintf,
+    * doubling if we didn't have enough space.
+    */
+   unsigned int bufSize;
+   char *buf;
+   int retval;
+
+   bufSize = strlen(format);
+   buf = NULL;
+
+   do {
+      /*
+       * Initial allocation of strlen(format) * 2. Should this be tunable?
+       * XXX Yes, this could overflow and spin forever when you get near 2GB
+       *     allocations. I don't care. --rrdharan
+       */
+
+      __va_list tmpArgs;
+
+      bufSize *= 2;
+      buf = realloc(buf, bufSize);
+
+      if (!buf) {
+         return NULL;
+      }
+
+      __va_copy(tmpArgs, arguments);
+      retval = Str_Vsnprintf(buf, bufSize, format, tmpArgs);
+      __va_end(tmpArgs);
+   } while (retval == -1);
+
+   if (length) {
+      *length = retval;
+   }
+
+   /*
+    * Try to trim the buffer here to save memory?
+    */
+   return buf;
+}
+
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * Str_Asprintf --
+ *
+ *    Same as Str_Vasprintf(), but parameters are passed inline --hpreg
+ *
+ * Results:
+ *    Same as Str_Vasprintf()
+ *
+ * Side effects:
+ *    Same as Str_Vasprintf()
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+char *
+Str_Asprintf(size_t *length,       // OUT
+             const char *format,   // IN
+             ...)                  // IN
+{
+   __va_list arguments;
+   char *result;
+
+   __va_start(arguments, format);
+   result = Str_Vasprintf(length, format, arguments);
+   __va_end(arguments);
+
+   return result;
+}
